  Set = {}

function Set.sum (a,b)
      if getmetatable(a) ~= Set.mt or getmetatable(b) ~= Set.mt then
        error("attempt to `add' a set with a non-set value", 2)
      end
      local res = Vector2d(a.x+b.x,a.y+b.y)
      return res
end


function Set.equal (a,b)
      if getmetatable(a) ~= Set.mt or getmetatable(b) ~= Set.mt then
        error("attempt to `compare' a set with a non-set value", 2)
      end
return (a.x==b.x and a.y==b.y)
end

function Set.sub(a,b)
      if getmetatable(a) ~= Set.mt or getmetatable(b) ~= Set.mt then
        error("attempt to `subtract' a set with a non-set value", 2)
      end
      local res = Vector2d(a.x-b.x,a.y-b.y)
      return res
end

function Set.unm(a)
	local res = Vector2d(-a.x,-a.y)
       return res
end

function Set.tostring(a)
	return "("..a.x..","..a.y..")"
end

function Set.multiply(a,b)  --at least one must be a vector
	if tonumber(a) then --scalar
		return vec(a*b.x,a*b.y)
	elseif tonumber(b) then --scalar
		return vec(b*a.x,b*a.y)
	else			--dot product
		return a.x*b.x+a.y*b.y	--returns a scalar
	end
end

Set.mt = {}    -- metatable for sets

--[[function Set.new (t)   -- 2nd version
      local set = {}
      setmetatable(set, Set.mt)
      --for _, l in ipairs(t) do set[l] = true end
      return set
end]]

function Set:magnitude()
	return math.sqrt(self.x^2 + self.y^2)
end


function Set:normalize()
	return (1/self:magnitude())*self
end

 Set.mt.__add = Set.sum
 Set.mt.__eq = Set.equal
 Set.mt.__index = Set
 Set.mt.__sub = Set.sub
 Set.mt.__unm = Set.unm
 Set.mt.__mul = Set.multiply
 Set.mt.__tostring = Set.tostring


function Vector2d(x,y)
	local vec = {x=x,y=y}
	setmetatable(vec, Set.mt)
	return vec
end

vec = Vector2d